org.apache.sysds.common

## Enum Builtins

- java.lang.Object
- - java.lang.Enum<Builtins>
  - - org.apache.sysds.common.Builtins

- All Implemented Interfaces:
    Serializable, Comparable<Builtins>

      public enum Builtins
      extends Enum<Builtins>

  Enum to represent all builtin functions in the default name space. Each function is either native or implemented by a DML script. In case of DML script, these functions are loaded during parsing. As always, user-defined DML-bodied functions take precedence over all builtin functions. To add a new builtin script function, simply add the definition here as well as a dml file in scripts/builtin with a matching name. On building SystemDS, these scripts are packaged into the jar as well.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ABS`
    `ACOS`
    `ASIN`
    `ATAN`
    `AVG_POOL`
    `AVG_POOL_BACKWARD`
    `BATCH_NORM2D`
    `BATCH_NORM2D_BACKWARD`
    `BIASADD`
    `BIASMULT`
    `BITWAND`
    `BITWOR`
    `BITWSHIFTL`
    `BITWSHIFTR`
    `BITWXOR`
    `CAST_AS_BOOLEAN`
    `CAST_AS_DOUBLE`
    `CAST_AS_FRAME`
    `CAST_AS_INT`
    `CAST_AS_MATRIX`
    `CAST_AS_SCALAR`
    `CBIND`
    `CDF`
    `CEIL`
    `CHOLESKY`
    `COLMAX`
    `COLMEAN`
    `COLMIN`
    `COLNAMES`
    `COLPROD`
    `COLSD`
    `COLSUM`
    `COLVAR`
    `COMPONENTS`
    `CONFUSIONMATRIX`
    `CONV2D`
    `CONV2D_BACKWARD_DATA`
    `CONV2D_BACKWARD_FILTER`
    `COR`
    `COS`
    `COSH`
    `COUNT_DISTINCT`
    `COUNT_DISTINCT_APPROX`
    `COV`
    `CUMMAX`
    `CUMMIN`
    `CUMPROD`
    `CUMSUM`
    `CUMSUMPROD`
    `CVLM`
    `DBSCAN`
    `DETECTSCHEMA`
    `DIAG`
    `DISCOVER_FD`
    `DIST`
    `DROP_INVALID_LENGTH`
    `DROP_INVALID_TYPE`
    `EIGEN`
    `EVAL`
    `EXECUTE_PIPELINE`
    `EXISTS`
    `EXP`
    `FLOOR`
    `GLM`
    `GMM`
    `GNMF`
    `GRID_SEARCH`
    `GROUPEDAGG`
    `HYPERBAND`
    `IFELSE`
    `IMG_BRIGHTNESS`
    `IMG_CROP`
    `IMG_MIRROR`
    `IMPUTE_FD`
    `INTERQUANTILE`
    `INTERSECT`
    `INVCDF`
    `INVERSE`
    `IQM`
    `ISINF`
    `ISNA`
    `ISNAN`
    `KMEANS`
    `L2SVM`
    `LENGTH`
    `LINEAGE`
    `LIST`
    `LISTNV`
    `LM`
    `LMCG`
    `LMDS`
    `LMPREDICT`
    `LOG`
    `LOWER_TRI`
    `LSTM`
    `LSTM_BACKWARD`
    `LU`
    `MAP`
    `MAX`
    `MAX_POOL`
    `MAX_POOL_BACKWARD`
    `MEAN`
    `MEDIAN`
    `MICE`
    `MIN`
    `MOMENT`
    `MSVM`
    `MSVMPREDICT`
    `MULTILOGREG`
    `MULTILOGREGPREDICT`
    `NA_LOCF`
    `NAIVEBAYES`
    `NCOL`
    `NORMALIZE`
    `NROW`
    `ORDER`
    `OUTER`
    `OUTLIER`
    `OUTLIER_IQR`
    `OUTLIER_SD`
    `PARAMSERV`
    `PCA`
    `PCHISQ`
    `PEXP`
    `PF`
    `PNMF`
    `PNORM`
    `PPRED`
    `PROD`
    `PT`
    `QCHISQ`
    `QEXP`
    `QF`
    `QNORM`
    `QR`
    `QT`
    `QUANTILE`
    `RANGE`
    `RBIND`
    `REMOVE`
    `REPLACE`
    `REV`
    `RMEMPTY`
    `ROUND`
    `ROWINDEXMAX`
    `ROWINDEXMIN`
    `ROWMAX`
    `ROWMEAN`
    `ROWMIN`
    `ROWPROD`
    `ROWSD`
    `ROWSUM`
    `ROWVAR`
    `SAMPLE`
    `SCALE`
    `SD`
    `SEQ`
    `SIGMOID`
    `SIGN`
    `SIN`
    `SINH`
    `SLICEFINDER`
    `SMOTE`
    `SOLVE`
    `SQRT`
    `STEPLM`
    `SUM`
    `SVD`
    `TABLE`
    `TAN`
    `TANH`
    `TIME`
    `TO_ONE_HOT`
    `TOSTRING`
    `TRACE`
    `TRANS`
    `TRANSFORMAPPLY`
    `TRANSFORMCOLMAP`
    `TRANSFORMDECODE`
    `TRANSFORMENCODE`
    `TRANSFORMMETA`
    `TYPEOF`
    `UNIVAR`
    `UPPER_TRI`
    `VAR`
    `WINSORIZE`
    `XOR`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `contains(String name, boolean script, boolean parameterized)`
    `static Builtins` | `get(String name)`
    `static Builtins` | `get(String name, boolean params)`
    `String` | `getAlias()`
    `static String` | `getFilePath(String name)`
    `static String` | `getInternalFName(String name, Types.DataType dt)`
    `String` | `getName()`
    `boolean` | `isMultiReturn()`
    `boolean` | `isParameterized()`
    `boolean` | `isScript()`
    `static Builtins` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static Builtins[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ABS

          public static final Builtins ABS

    - #### ACOS

          public static final Builtins ACOS

    - #### ASIN

          public static final Builtins ASIN

    - #### ATAN

          public static final Builtins ATAN

    - #### AVG_POOL

          public static final Builtins AVG_POOL

    - #### AVG_POOL_BACKWARD

          public static final Builtins AVG_POOL_BACKWARD

    - #### BATCH_NORM2D

          public static final Builtins BATCH_NORM2D

    - #### BATCH_NORM2D_BACKWARD

          public static final Builtins BATCH_NORM2D_BACKWARD

    - #### BIASADD

          public static final Builtins BIASADD

    - #### BIASMULT

          public static final Builtins BIASMULT

    - #### BITWAND

          public static final Builtins BITWAND

    - #### BITWOR

          public static final Builtins BITWOR

    - #### BITWXOR

          public static final Builtins BITWXOR

    - #### BITWSHIFTL

          public static final Builtins BITWSHIFTL

    - #### BITWSHIFTR

          public static final Builtins BITWSHIFTR

    - #### CAST_AS_SCALAR

          public static final Builtins CAST_AS_SCALAR

    - #### CAST_AS_MATRIX

          public static final Builtins CAST_AS_MATRIX

    - #### CAST_AS_FRAME

          public static final Builtins CAST_AS_FRAME

    - #### CAST_AS_DOUBLE

          public static final Builtins CAST_AS_DOUBLE

    - #### CAST_AS_INT

          public static final Builtins CAST_AS_INT

    - #### CAST_AS_BOOLEAN

          public static final Builtins CAST_AS_BOOLEAN

    - #### CBIND

          public static final Builtins CBIND

    - #### CEIL

          public static final Builtins CEIL

    - #### COLMAX

          public static final Builtins COLMAX

    - #### COLMEAN

          public static final Builtins COLMEAN

    - #### COLMIN

          public static final Builtins COLMIN

    - #### COLNAMES

          public static final Builtins COLNAMES

    - #### COLPROD

          public static final Builtins COLPROD

    - #### COLSD

          public static final Builtins COLSD

    - #### COLSUM

          public static final Builtins COLSUM

    - #### COLVAR

          public static final Builtins COLVAR

    - #### COMPONENTS

          public static final Builtins COMPONENTS

    - #### CONV2D

          public static final Builtins CONV2D

    - #### CONV2D_BACKWARD_FILTER

          public static final Builtins CONV2D_BACKWARD_FILTER

    - #### CONV2D_BACKWARD_DATA

          public static final Builtins CONV2D_BACKWARD_DATA

    - #### COS

          public static final Builtins COS

    - #### COV

          public static final Builtins COV

    - #### COSH

          public static final Builtins COSH

    - #### CHOLESKY

          public static final Builtins CHOLESKY

    - #### CUMMAX

          public static final Builtins CUMMAX

    - #### CUMMIN

          public static final Builtins CUMMIN

    - #### CUMPROD

          public static final Builtins CUMPROD

    - #### CUMSUM

          public static final Builtins CUMSUM

    - #### CUMSUMPROD

          public static final Builtins CUMSUMPROD

    - #### CONFUSIONMATRIX

          public static final Builtins CONFUSIONMATRIX

    - #### COR

          public static final Builtins COR

    - #### DBSCAN

          public static final Builtins DBSCAN

    - #### DETECTSCHEMA

          public static final Builtins DETECTSCHEMA

    - #### DIAG

          public static final Builtins DIAG

    - #### DISCOVER_FD

          public static final Builtins DISCOVER_FD

    - #### DIST

          public static final Builtins DIST

    - #### DROP_INVALID_TYPE

          public static final Builtins DROP_INVALID_TYPE

    - #### DROP_INVALID_LENGTH

          public static final Builtins DROP_INVALID_LENGTH

    - #### EIGEN

          public static final Builtins EIGEN

    - #### EXISTS

          public static final Builtins EXISTS

    - #### EXECUTE_PIPELINE

          public static final Builtins EXECUTE_PIPELINE

    - #### EXP

          public static final Builtins EXP

    - #### EVAL

          public static final Builtins EVAL

    - #### FLOOR

          public static final Builtins FLOOR

    - #### GLM

          public static final Builtins GLM

    - #### GMM

          public static final Builtins GMM

    - #### GNMF

          public static final Builtins GNMF

    - #### GRID_SEARCH

          public static final Builtins GRID_SEARCH

    - #### HYPERBAND

          public static final Builtins HYPERBAND

    - #### IFELSE

          public static final Builtins IFELSE

    - #### IMG_MIRROR

          public static final Builtins IMG_MIRROR

    - #### IMG_BRIGHTNESS

          public static final Builtins IMG_BRIGHTNESS

    - #### IMG_CROP

          public static final Builtins IMG_CROP

    - #### IMPUTE_FD

          public static final Builtins IMPUTE_FD

    - #### INTERQUANTILE

          public static final Builtins INTERQUANTILE

    - #### INTERSECT

          public static final Builtins INTERSECT

    - #### INVERSE

          public static final Builtins INVERSE

    - #### IQM

          public static final Builtins IQM

    - #### ISNA

          public static final Builtins ISNA

    - #### ISNAN

          public static final Builtins ISNAN

    - #### ISINF

          public static final Builtins ISINF

    - #### KMEANS

          public static final Builtins KMEANS

    - #### L2SVM

          public static final Builtins L2SVM

    - #### LENGTH

          public static final Builtins LENGTH

    - #### LINEAGE

          public static final Builtins LINEAGE

    - #### LIST

          public static final Builtins LIST

    - #### LM

          public static final Builtins LM

    - #### LMCG

          public static final Builtins LMCG

    - #### LMDS

          public static final Builtins LMDS

    - #### LMPREDICT

          public static final Builtins LMPREDICT

    - #### LOG

          public static final Builtins LOG

    - #### LSTM

          public static final Builtins LSTM

    - #### LSTM_BACKWARD

          public static final Builtins LSTM_BACKWARD

    - #### LU

          public static final Builtins LU

    - #### MAP

          public static final Builtins MAP

    - #### MEAN

          public static final Builtins MEAN

    - #### MICE

          public static final Builtins MICE

    - #### MIN

          public static final Builtins MIN

    - #### MAX

          public static final Builtins MAX

    - #### MAX_POOL

          public static final Builtins MAX_POOL

    - #### MAX_POOL_BACKWARD

          public static final Builtins MAX_POOL_BACKWARD

    - #### MEDIAN

          public static final Builtins MEDIAN

    - #### MOMENT

          public static final Builtins MOMENT

    - #### MSVM

          public static final Builtins MSVM

    - #### MSVMPREDICT

          public static final Builtins MSVMPREDICT

    - #### MULTILOGREG

          public static final Builtins MULTILOGREG

    - #### MULTILOGREGPREDICT

          public static final Builtins MULTILOGREGPREDICT

    - #### NA_LOCF

          public static final Builtins NA_LOCF

    - #### NCOL

          public static final Builtins NCOL

    - #### NORMALIZE

          public static final Builtins NORMALIZE

    - #### NROW

          public static final Builtins NROW

    - #### NAIVEBAYES

          public static final Builtins NAIVEBAYES

    - #### OUTER

          public static final Builtins OUTER

    - #### OUTLIER

          public static final Builtins OUTLIER

    - #### OUTLIER_SD

          public static final Builtins OUTLIER_SD

    - #### OUTLIER_IQR

          public static final Builtins OUTLIER_IQR

    - #### PCA

          public static final Builtins PCA

    - #### PNMF

          public static final Builtins PNMF

    - #### PPRED

          public static final Builtins PPRED

    - #### PROD

          public static final Builtins PROD

    - #### QR

          public static final Builtins QR

    - #### QUANTILE

          public static final Builtins QUANTILE

    - #### RANGE

          public static final Builtins RANGE

    - #### RBIND

          public static final Builtins RBIND

    - #### REMOVE

          public static final Builtins REMOVE

    - #### REV

          public static final Builtins REV

    - #### ROUND

          public static final Builtins ROUND

    - #### ROWINDEXMAX

          public static final Builtins ROWINDEXMAX

    - #### ROWINDEXMIN

          public static final Builtins ROWINDEXMIN

    - #### ROWMIN

          public static final Builtins ROWMIN

    - #### ROWMAX

          public static final Builtins ROWMAX

    - #### ROWMEAN

          public static final Builtins ROWMEAN

    - #### ROWPROD

          public static final Builtins ROWPROD

    - #### ROWSD

          public static final Builtins ROWSD

    - #### ROWSUM

          public static final Builtins ROWSUM

    - #### ROWVAR

          public static final Builtins ROWVAR

    - #### SAMPLE

          public static final Builtins SAMPLE

    - #### SD

          public static final Builtins SD

    - #### SEQ

          public static final Builtins SEQ

    - #### SIGMOID

          public static final Builtins SIGMOID

    - #### SIGN

          public static final Builtins SIGN

    - #### SIN

          public static final Builtins SIN

    - #### SINH

          public static final Builtins SINH

    - #### STEPLM

          public static final Builtins STEPLM

    - #### SLICEFINDER

          public static final Builtins SLICEFINDER

    - #### SMOTE

          public static final Builtins SMOTE

    - #### SOLVE

          public static final Builtins SOLVE

    - #### SQRT

          public static final Builtins SQRT

    - #### SUM

          public static final Builtins SUM

    - #### SVD

          public static final Builtins SVD

    - #### TRANS

          public static final Builtins TRANS

    - #### TABLE

          public static final Builtins TABLE

    - #### TAN

          public static final Builtins TAN

    - #### TANH

          public static final Builtins TANH

    - #### TRACE

          public static final Builtins TRACE

    - #### TO_ONE_HOT

          public static final Builtins TO_ONE_HOT

    - #### TYPEOF

          public static final Builtins TYPEOF

    - #### COUNT_DISTINCT

          public static final Builtins COUNT_DISTINCT

    - #### COUNT_DISTINCT_APPROX

          public static final Builtins COUNT_DISTINCT_APPROX

    - #### VAR

          public static final Builtins VAR

    - #### XOR

          public static final Builtins XOR

    - #### UNIVAR

          public static final Builtins UNIVAR

    - #### WINSORIZE

          public static final Builtins WINSORIZE

    - #### CDF

          public static final Builtins CDF

    - #### GROUPEDAGG

          public static final Builtins GROUPEDAGG

    - #### INVCDF

          public static final Builtins INVCDF

    - #### LISTNV

          public static final Builtins LISTNV

    - #### LOWER_TRI

          public static final Builtins LOWER_TRI

    - #### ORDER

          public static final Builtins ORDER

    - #### PARAMSERV

          public static final Builtins PARAMSERV

    - #### PCHISQ

          public static final Builtins PCHISQ

    - #### PEXP

          public static final Builtins PEXP

    - #### PF

          public static final Builtins PF

    - #### PNORM

          public static final Builtins PNORM

    - #### PT

          public static final Builtins PT

    - #### QCHISQ

          public static final Builtins QCHISQ

    - #### QF

          public static final Builtins QF

    - #### QNORM

          public static final Builtins QNORM

    - #### QT

          public static final Builtins QT

    - #### QEXP

          public static final Builtins QEXP

    - #### REPLACE

          public static final Builtins REPLACE

    - #### RMEMPTY

          public static final Builtins RMEMPTY

    - #### SCALE

          public static final Builtins SCALE

    - #### TIME

          public static final Builtins TIME

    - #### CVLM

          public static final Builtins CVLM

    - #### TOSTRING

          public static final Builtins TOSTRING

    - #### TRANSFORMAPPLY

          public static final Builtins TRANSFORMAPPLY

    - #### TRANSFORMCOLMAP

          public static final Builtins TRANSFORMCOLMAP

    - #### TRANSFORMDECODE

          public static final Builtins TRANSFORMDECODE

    - #### TRANSFORMENCODE

          public static final Builtins TRANSFORMENCODE

    - #### TRANSFORMMETA

          public static final Builtins TRANSFORMMETA

    - #### UPPER_TRI

          public static final Builtins UPPER_TRI

  - ### Method Detail

    - #### values

          public static Builtins[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Builtins c : Builtins.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Builtins valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getName

          public String getName()

    - #### getAlias

          public String getAlias()

    - #### isScript

          public boolean isScript()

    - #### isParameterized

          public boolean isParameterized()

    - #### isMultiReturn

          public boolean isMultiReturn()

    - #### contains

          public static boolean contains(String name,
                                         boolean script,
                                         boolean parameterized)

    - #### get

          public static Builtins get(String name)

    - #### get

          public static Builtins get(String name,
                                     boolean params)

    - #### getFilePath

          public static String getFilePath(String name)

    - #### getInternalFName

          public static String getInternalFName(String name,
                                                Types.DataType dt)

Copyright © 2020 The Apache Software Foundation. All rights reserved.